(*
	When I manually create the columns and use the HTMLTemplate property
	of the Column the TMSFNCGrid1GetCellLayout doesn't work.
*)
unit UDemo;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.TMSFNCCustomComponent, FMX.TMSFNCCustomGrid,
  FMX.TMSFNCGridDatabaseAdapter, Data.DB, Datasnap.DBClient,
  FMX.TMSFNCCustomControl, FMX.TMSFNCCustomScrollControl, FMX.TMSFNCGridData,
  FMX.TMSFNCGrid, Data.Bind.Controls, FMX.Layouts, Fmx.Bind.Navigator,
  FMX.Controls.Presentation, FMX.TMSFNCGridOptions, FMX.TMSFNCGraphics,
  Data.Bind.Components, Data.Bind.DBScope, FMX.TMSFNCTypes, FMX.TMSFNCUtils,
  FMX.TMSFNCGraphicsTypes, FMX.TMSFNCGridCell;

type
  TForm130 = class(TForm)
    TMSFNCGrid1: TTMSFNCGrid;
    TMSFNCGridDatabaseAdapter1: TTMSFNCGridDatabaseAdapter;
    ClientDataSet1: TClientDataSet;
	DataSource1: TDataSource;
    procedure FormCreate(Sender: TObject);
    procedure TMSFNCGrid1GetCellLayout(Sender: TObject; ACol, ARow: Integer;
      ALayout: TTMSFNCGridCellLayout; ACellState: TTMSFNCGridCellState);
  private
    procedure AddColumns;
    procedure TMSStartUp;
  public
    { Public declarations }
  end;

var
  Form130: TForm130;

implementation

{$R *.fmx}

procedure TForm130.AddColumns;
var
	aColumn : TTMSFNCGridDatabaseAdapterColumn;
begin
	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'ID';
	aColumn.HTMLTemplate := '<#ID>';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Brand';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Model';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Cylinder';
	aColumn.HTMLTemplate := '<#Cylinder>';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'AverageSpeed';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Gearbox';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'TopSpeed';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Price';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'OrderDate';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Stock';

	aColumn := TMSFNCGridDatabaseAdapter1.Columns.Add;
	aColumn.FieldName := 'Logo';

end;

procedure TForm130.FormCreate(Sender: TObject);
begin
	TMSStartUp;
end;

procedure TForm130.TMSStartUp;
begin
	ClientDataSet1.Active := False;
    DataSource1.DataSet := ClientDataSet1;
    TMSFNCGridDatabaseAdapter1.DataSource := DataSource1;
    TMSFNCGridDatabaseAdapter1.Grid := TMSFNCGrid1;

    TMSFNCGridDatabaseAdapter1.AutoCreateColumns := false;
    TMSFNCGridDatabaseAdapter1.AutoRemoveColumns := false;
	AddColumns;

	TMSFNCGrid1.Options.Bands.Enabled := True;
    TMSFNCGrid1.DefaultRowHeight := 30;
    TMSFNCGrid1.ColumnWidths[0] := 25;
    TMSFNCGrid1.ColumnWidths[1] := 25;
    TMSFNCGrid1.ColumnWidths[2] := 100;
    TMSFNCGrid1.ColumnWidths[3] := 100;
    TMSFNCGrid1.ColumnWidths[4] := 65;
    TMSFNCGrid1.ColumnWidths[5] := 100;
    TMSFNCGrid1.ColumnWidths[10] := 50;
    TMSFNCGrid1.Options.Selection.Mode := smSingleRow;
    TMSFNCGrid1.Appearance.FocusedLayout.Fill.Color := gcGreen;
    TMSFNCGrid1.Appearance.SelectedLayout.Fill.Color := gcYellowgreen;
	TMSFNCGrid1.Appearance.BandLayout.Fill.Color := gcWhitesmoke;
    ClientDataSet1.Active := True;
    TMSFNCGridDatabaseAdapter1.Active := True;
	TMSFNCGrid1.Options.ColumnSize.Stretch := True;
end;



type
  TTMSFNCGridDataBaseAdapterOpen = class(TTMSFNCGridDataBaseAdapter);


procedure TForm130.TMSFNCGrid1GetCellLayout(Sender: TObject; ACol,
  ARow: Integer; ALayout: TTMSFNCGridCellLayout;
  ACellState: TTMSFNCGridCellState);
var
  d: TTMSFNCGridDataBaseAdapterOpen;
  ar, c, r: Integer;
  f: TField;
  i: Integer;
begin
  r := ARow;

  if (r <= TMSFNCGrid1.FixedRows - 1) then
	Exit;

  c := ACol - TMSFNCGrid1.FixedColumns;

  if (c >= 0) and (c <= TMSFNCGrid1.Columns.Count - 1) then
  begin
	d := TTMSFNCGridDataBaseAdapterOpen(TMSFNCGridDatabaseAdapter1);
	if d.CheckDataSet then
    begin
      ar := d.DataLink.ActiveRecord;
      try
        d.SetActiveRecord(ARow);
        f := d.FieldAtColumn[c];
        if Assigned(f) then
		begin
		  i := 0;
          if TryStrToInt(f.AsString, i) then
          begin
            if i > 2500 then
            begin
              ALayout.Fill.Color := gcRed;
            end;
          end;
		end;
      finally
        d.DataLink.ActiveRecord := ar;
      end;
    end;
  end;
end;

end.
